import socket
import struct
import random
import time
import string

import hashlib
from tkio import clickios
from tkio import tkioreceive

def idfacode():
    ret = ''
    a = "".join(random.sample(string.ascii_letters + string.digits, 8))
    b = "".join(random.sample(string.ascii_letters + string.digits, 4))
    c = "".join(random.sample(string.ascii_letters + string.digits, 4))
    d = "".join(random.sample(string.ascii_letters + string.digits, 4))
    e = "".join(random.sample(string.ascii_letters + string.digits, 12))
    i = (a + "-" + b + "-" + c + "-" + d + "-" + e).upper()
    ret += i
    return ret



# md5加密转大写
def computeMD5upper(message):
    m = hashlib.md5()
    m.update(message.encode(encoding='utf-8'))
    return m.hexdigest().upper()


# 生成小写字母加数字组合
n = 10
def code_nums1(n=6):
    ret = ''
    for i in range(n):
        num = random.randint(0, 9)
        letter = chr(random.randint(97, 122))
        s = str(random.choice([num, letter]))
        ret += s
    return ret

# 1.点击1:idfa=111，ip=222
# 2.点击2:idfa=444，ip=333
# 3.激活：idfa=111，ip=333
# 归因到点击1
def test_at1():
    i = idfacode()
    i2 = idfacode()
    ip1 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    ip2 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    clickios.parms['idfa'] = i
    clickios.parms['ip'] = ip1
    clickios.send_requestandroid('')
    time.sleep(3)
    clickios.parms['idfa'] = i2
    clickios.parms['ip'] = ip2
    clickios.send_requestandroid('')
    time.sleep(5)
    tkioreceive.data['context']['_deviceid'] = i
    tkioreceive.data['context']['_idfa'] = i
    tkioreceive.data['context']['_ip'] = ip2
    tkioreceive.send_request()
    print(i)
    print(i2)
    print(ip1)
    print(ip2)


# 1.点击1:idfa=111，ip=222.点击2:idfa=444，ip=3333.激活：idfa=444，ip=222
# 归因到点击2
def test_at2():
    i = idfacode()
    i2 = idfacode()
    ip1 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    ip2 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    clickios.parms['idfa'] = i
    clickios.parms['ip'] = ip1
    clickios.send_requestandroid('')
    time.sleep(3)
    clickios.parms['idfa'] = i2
    clickios.parms['ip'] = ip2
    clickios.send_requestandroid('')
    time.sleep(5)
    tkioreceive.data['context']['_deviceid'] = i2
    tkioreceive.data['context']['_idfa'] = i2
    tkioreceive.data['context']['_ip'] = ip1
    tkioreceive.send_request()
    print(i)
    print(i2)
    print(ip1)
    print(ip2)



# 点击激活的idfa，caid，ip+ua，ip都相同，归因方式为idfa
def test_at3():
    i = idfacode()
    i2 = idfacode()
    ip1 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    ip2 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    clickios.parms['idfa'] = i
    clickios.parms['ip'] = ip1
    clickios.send_requestandroid('')
    time.sleep(3)
    clickios.parms['idfa'] = i2
    clickios.parms['ip'] = ip2
    clickios.send_requestandroid('')
    time.sleep(5)
    tkioreceive.data['context']['_deviceid'] = i2
    tkioreceive.data['context']['_idfa'] = i2
    tkioreceive.data['context']['_ip'] = ip1
    tkioreceive.send_request()
    print(i)
    print(i2)
    print(ip1)
    print(ip2)



# 在优先级同样的情况下，优先匹配lastclick
def test_at4():
    i = idfacode()
    i2 = idfacode()
    ip1 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    ip2 = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    clickios.parms['idfa'] = i
    clickios.parms['ip'] = ip1
    clickios.send_requestandroid('')
    time.sleep(3)
    clickios.parms['idfa_MD5'] = computeMD5upper(i)
    clickios.parms['idfa'] = i2
    clickios.parms['ip'] = ip2
    clickios.send_requestandroid('')
    time.sleep(5)
    tkioreceive.data['context']['_deviceid'] = i
    tkioreceive.data['context']['_idfa'] = i
    tkioreceive.data['context']['_ip'] = ip1
    tkioreceive.send_request()
    print(i)
    print(i2)
    print(ip1)
    print(ip2)


# 激活的idfa与点击idfa_MD5相同，caid，ip+ua，ip都相同，归因方式为idfa_MD5
def test_at5():
    i = idfacode()
    caid = code_nums1(32)
    ip = socket.inet_ntoa(struct.pack('>I', random.randint(1, 0xffffffff)))
    clickios.parms['idfa_MD5'] = computeMD5upper(i)
    clickios.parms['idfa'] = i
    clickios.parms['ip'] = ip
    clickios.parms['caid'] = caid
    clickios.send_requestandroid('')
    time.sleep(5)
    tkioreceive.data['context']['_deviceid'] = i
    tkioreceive.data['context']['_idfa'] = i
    tkioreceive.data['context']['_ip'] = ip
    tkioreceive.data['context']['_caid1'] = caid
    tkioreceive.send_request()
    print(i)
    print(ip)
